/*---------------------------------------------------------------------------
      Chapter 2: Declarative Programming ( )
      This code is part of the book
      LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
      Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
      Hellenic Academic On-line Publications, 2015
    ----------------------------------------------------------------------------*/

/*    Comparing the implementation of factorial: Java vs Prolog Implementation  

int factorial(int N) throws wrongInput 
{
        if (N==0) return 1;
        int NP=1;
        if (N>0)
for (int Counter=1; i<=N; i=i+1)
                NP=NP*Counter;
        else throw new wrongInput("   ");
        return NP; 
}
*/

factorial(0,1).
factorial(N, NP):-
  N>0,
  N1 is N-1,
  factorial(N1,NP1),
  NP is N*NP1.
